#!/bin/bash
# 15) Wallpapers de centro en función de sus etiquetas migasfree:

function ajustar_resolucion_wallpaper() {
    # Por compatibilidad con lo hecho en el IES Virgen del Pilar
    # Actualmente toda su lógica se ha llevado al script: usr/bin/vx-wallpaper-centro-conf-cli
    RESOLUCION=$(/usr/bin/obtener-resolucion-pantalla)
    [ "$RESOLUCION" = "" ] && RESOLUCION="Indeterminada"
    _FILE1=/usr/share/vitalinux/wallpapers/vitalinux-edu-wallpaper.png
    _FILE2=/usr/share/vitalinux/wallpapers/vitalinux-login.png
    echo "=> Ajustando Wallpaper a Resolución: ${RESOLUCION}"
    case $RESOLUCION in
    "4:3")
        cp /usr/share/vitalinux/wallpapers/vitalinux-edu-wallpaper-4x3-1600x1200.png $_FILE1
        cp /usr/share/vitalinux/wallpapers/vitalinux-login-4x3-1600x1200.png $_FILE2
        ;;
    "16:9")
        cp /usr/share/vitalinux/wallpapers/vitalinux-edu-wallpaper-16x9-1920x1080.png $_FILE1
        cp /usr/share/vitalinux/wallpapers/vitalinux-login-16x9-1920x1080.png $_FILE2
        ;;
    *)
        # Por defecto dejamos la 16x9
        cp /usr/share/vitalinux/wallpapers/vitalinux-edu-wallpaper-16x9-1920x1080.png $_FILE1
        cp /usr/share/vitalinux/wallpapers/vitalinux-login-16x9-1920x1080.png $_FILE2
        ;;
    esac
    # GREETER
    FILEGREETER="/etc/lightdm/lightdm-gtk-greeter.conf.d/99_vitalinux.conf"
    [ -f $FILEGREETER ] &&
        sed -i --follow-symlinks "s#background=.*#background=${_FILE2}#g" $FILEGREETER
}

function cambiar_wallpaper() {
    # Por compatibilidad con lo hecho en el IES Virgen del Pilar:
    # Actualmente toda su lógica se ha llevado al script: usr/bin/vx-wallpaper-centro-conf-cli
    DIRECTORIO="${1}"
    DIRORIGINALES="/usr/share/divert/usr/share/vitalinux/wallpapers"
    FICHEROS=("vitalinux-edu-wallpaper-16x9-1920x1080.png"
        "vitalinux-edu-wallpaper-4x3-1600x1200.png"
        "vitalinux-login-16x9-1920x1080.png"
        "vitalinux-login-4x3-1600x1200.png")
    RESULTADO="true"
    for FICH in ${FICHEROS[@]}; do
        if [[ -f "${DIRECTORIO}/${FICH}" && -f "${DIRORIGINALES}/${FICH}" ]]; then
            MD5FICH="$(md5sum "${DIRECTORIO}/${FICH}" | cut -d" " -f1)"
            MD5FICHORI="$(md5sum "${DIRORIGINALES}/${FICH}" | cut -d" " -f1)"
            if [[ "${MD5FICH}" != "${MD5FICHORI}" ]]; then
                mv -f "${DIRORIGINALES}/${FICH}" "${DIRORIGINALES}/${FICH}.ant"
                cp "${DIRECTORIO}/${FICH}" "${DIRORIGINALES}/${FICH}" &&
                    echo "=> Se ha impuesto el Wallpaper: ${FICH}"
            else
                echo "=> Ya esta impuesto el Wallpaper: ${FICH}"
            fi
        else
            echo "=> Problemas con Wallpaper: ${FICH}"
            RESULTADO="false"
        fi
    done
    if "${RESULTADO}"; then
        ajustar_resolucion_wallpaper
        "${echo_verde}" "=> ¡¡Ok!! Se ha modificado el Wallpaper por defecto: ${DIRECTORIO}"
    else
        "${echo_rojo}" "=> ¡¡Error!! No se ha podido modificar el Wallpaper por defecto: ${DIRECTORIO}"
    fi
    return 0
}

function configurar_wallpapers() {
    PARAM="${1}"
    CONT="${2}"
    # Por compatibilidad con lo hecho en el IES Virgen del Pilar:
    DIRECTORIO="$(jq -r ".${PARAM}[${CONT}].directorio" <<<"${JSON}")"
    [[ "${DIRECTORIO}" != "null" && -d "${DIRECTORIO}" ]] &&
        cambiar_wallpaper "${DIRECTORIO}" && return 0
    # Rescatamos el directorio base del divert donde están los Wallpapers:
    ACCION="$(jq -r ".${PARAM}[${CONT}].accion" <<<"${JSON}")"
    PAQUETECENTRO="$(jq -r ".${PARAM}[${CONT}].paquetecentro" <<<"${JSON}")"
    BASEDIVERT="$(jq -r ".${PARAM}[${CONT}].dirbasedivert" <<<"${JSON}")"
    # Comprobamos el formato de la ruta del directorio que contiene los archivos a divertir:
    [[ "${BASEDIVERT}" =~ ^/usr/share/divert ]] &&
        DIRBASEDIVERT="${BASEDIVERT}" ||
        DIRBASEDIVERT="/usr/share/divert${BASEDIVERT}"
    DIRBASEWALLPAPERS="/usr/share/vitalinux/wallpapers"
    # Lanzamos el ejecutable encargado de la imposición del Wallpaper:
    EJECUTABLE="/usr/bin/vx-wallpaper-centro-conf-cli"
    if [[ -x "${EJECUTABLE}" ]] &&
        "${EJECUTABLE}" "${ACCION}" "${PAQUETECENTRO}" "${DIRBASEDIVERT}"; then
        "${echo_verde}" "=> ¡¡Ok!! Se ha modificado el Wallpaper por defecto: ${DIRBASEWALLPAPERS}"
    else
        "${echo_rojo}" "=> ¡¡Error!! No se ha podido modificar el Wallpaper por defecto: ${DIRBASEWALLPAPERS}"
    fi
}

"${echo_titulo}" "*  [[ Configurar Wallpapers Extras de Centro ... ]]  *"
PARAM="wallpapers.lista"
# check_parametro [parametro] [breve descripción] [función a llamar]
check_parametro "${PARAM}" "Wallpapers Extra" "configurar_wallpapers"
