#!/bin/bash
# 17) Configuración de atajos de teclado:

function configurar_atajos_teclado() {
    PARAM="${1}"
    CONT="${2}"
    # Rescatamos las acciones a relizar (add o del), los atajos a configurar y sus comandos correspondientes (p.e. IES Mequinenza):
    ACCION="$(jq -r ".${PARAM}[${CONT}].accion" <<<"${JSON}")"
    ATAJO="$(jq -r ".${PARAM}[${CONT}].atajo" <<<"${JSON}")"
    COMANDO="$(jq -r ".${PARAM}[${CONT}].comando" <<<"${JSON}")"
    EJECUTABLE="/usr/bin/vx-conf-atajos-teclado"
    if [[ -x "${EJECUTABLE}" ]] && "${EJECUTABLE}" "${ACCION}" "${ATAJO}" "${COMANDO}"; then
        "${echo_verde}" "=> ¡¡Ok!! Se ha configurado correctamente el atajo: ${ATAJO}:${COMANDO}"
    else
        "${echo_rojo}" "=> ¡¡Error!! Problemas al configurar el atajo: ${ATAJO}:${COMANDO}"
    fi
}

"${echo_titulo}" "*  [[ Configuración de Atajos de Teclado ... ]]  *"
PARAM="atajosteclado.lista"
# check_parametro [parametro] [breve descripción] [función a llamar]
check_parametro "${PARAM}" "Configurar Atajos de Teclado" "configurar_atajos_teclado"
