#!/bin/bash
# 21) Configuración de los bookmarks:

function configurar_bookmarks() {
    PARAM="${1}"
    CONT="${2}"
    # Rescatamos los valores del canal, directiva y valor:
    ACCION="$(jq -r ".${PARAM}[${CONT}].accion" <<<"${JSON}")"
    # La variable URL puede ser la url completa o null. En caso de null la url se formará a partir de tipo y ruta:
    URL="$(jq -r ".${PARAM}[${CONT}].url" <<<"${JSON}")"
    if [[ "${URL}" == "null" ]] ; then
        # Creamos la URL a partir de la ruta absoluta, o relativa en relación al HOME del usuario, y el tipo recibidos: 
        # p.e. TIPO="file://" y RUTA="Descargas/pdfs" => URL="file:///home/usuario/Descargas/pdfs"
        TIPO="$(jq -r ".${PARAM}[${CONT}].tipo" <<<"${JSON}")"
        RUTA="$(jq -r ".${PARAM}[${CONT}].ruta" <<<"${JSON}")"
        vx-funcs-bash vx-regex_path_absolute "${RUTA}" || RUTA="$(vx-home-usuario-grafico)/${RUTA}"
        URL="${TIPO}${RUTA}"
    fi
    ALIAS="$(jq -r ".${PARAM}[${CONT}].alias" <<<"${JSON}")"
    [[ "${ALIAS}" == "null" ]] && ALIAS="$(basename "${RUTA}")"
    EJECUTABLE="/usr/bin/vx-bookmarks"
    # Llamamos al ejecutable pasando los parámetros necesarios:
    if [[ -x "${EJECUTABLE}" ]] &&
        "${EJECUTABLE}" "${ACCION}" "${URL}" "${ALIAS}" ; then
        "${echo_verde}" "=> ¡¡Ok!! Bookmark [${ACCION}]: ${RUTA} => ${ALIAS}"
    else
        "${echo_rojo}" "=> ¡¡Error!! Bookmark [${ACCION}]: ${RUTA} => ${ALIAS}"
    fi
}

"${echo_titulo}" "*  [[ Bookmarks: Configuración de los Bookmarks del Explorador de Archivos ]]  *"
PARAM="bookmarks.lista"
# check_parametro [parametro] [breve descripción] [función a llamar]
check_parametro "${PARAM}" "Bookmarks: Configuración de los Bookmarks del Explorador de Archivos" "configurar_bookmarks"
